HRSS
======
HRSS is an application that allows you to transform any website into a RSS feed.

![Header](https://i.hipstercat.fr/storage/eLhX14B.png)

# Usage

 - Fill an URL in the homepage field then click **Setup**.
 - Click on a field on the left panel, then hover and select the element on the right panel.
	![Setup](https://i.hipstercat.fr/storage/eT5HyMd.png)
 - Fill at least the **Element**, **Title** and **Content** fields, then click on **Generate**.
 - Your RSS feed is ready and shown on the next page.
	![Feeds](https://i.hipstercat.fr/storage/eTeLAMp.png)

# Features
 
 - Free and open-source. No limits.
 - No complicated installation procedure (if you know how to setup a Django app).
 - No database needed (H2 file used).
 - Works for 80% of websites out there.
	 - **Why does it not work for every website?**
	   Mainly because Javascript on these websites do some obscure checks and do not permit iframes. Ideas of workarounds are welcome.
- No user management at the moment (self-host your own instance and protect it with a basic auth if you want security).
- Fully working in most RSS readers (I use Tiny Tiny RSS and it works great).

# Demo

[Because we all love demos.](https://hrss.hipstercat.fr)

# Installation (native)

 1. Make sure you have Python3 installed and virtualenv.
 2. Clone this repo for unstable branch, or download [latest release](https://hipstercat.fr/gogs/hipstercat/hrss/releases).
 3. `cd hrss && python3 -m virtualenv --python=python3 .`to create a new virtualenv.
 4. `bin/activate && pip3 install -r requirements.txt` to install dependencies.
 5. `python3 manage.py migrate` to apply latest DB migrations (and create the H2 database file).
 6. `python3 manage.py runserver` to run the integrated webserver (not suitable for production use - even though you should not use HRSS in a production environnement at all until it is considered stable anyway). Use uWSGI to run it in a production environnement.
 
# Installation (Docker)

 Use https://github.com/kmlucy/docker-hrss nicely made by [kmlucy](https://github.com/kmlucy).